// Join
`include "global.vh"
module xmas_join (clk, rst,
    a$irdy, a$trdy, a$data,
    b$irdy, b$trdy, b$data,
    o$irdy, o$trdy, o$data);

input clk, rst;

input a$irdy;
output a$trdy;
input [`DATA_WIDTH-1:0] a$data;

input b$irdy;
output b$trdy;
input [`DATA_WIDTH-1:0] b$data;

output o$irdy;
input o$trdy;
output [`DATA_WIDTH-1:0] o$data;
    
// arbitration state
reg u;
    
assign o$irdy = a$irdy && b$irdy;
assign o$data = a$data; // TODO: h(a,b)
assign a$trdy = o$trdy && b$irdy;
assign b$trdy = o$trdy && a$irdy;
endmodule
